<?xml version='1.0' encoding='utf-8'?>
<FilingSummary>
  <Version>3.24.0.1</Version>
  <ProcessingTime/>
  <ReportFormat>html</ReportFormat>
  <ContextCount>140</ContextCount>
  <ElementCount>28</ElementCount>
  <EntityCount>1</EntityCount>
  <FootnotesReported>false</FootnotesReported>
  <SegmentCount>19</SegmentCount>
  <ScenarioCount>0</ScenarioCount>
  <TuplesReported>false</TuplesReported>
  <UnitCount>3</UnitCount>
  <MyReports>
    <Report instance="txrh-20240516xpre14a.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R1.htm</HtmlFileName>
      <LongName>00090 - Document - Document and Entity Information</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://texasroadhouse.com/role/DocumentDocumentAndEntityInformation</Role>
      <ShortName>Document and Entity Information</ShortName>
      <MenuCategory>Cover</MenuCategory>
      <Position>1</Position>
    </Report>
    <Report instance="txrh-20240516xpre14a.htm">
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <HtmlFileName>R2.htm</HtmlFileName>
      <LongName>995410 - Disclosure - Pay vs Performance Disclosure</LongName>
      <ReportType>Sheet</ReportType>
      <Role>http://xbrl.sec.gov/ecd/role/PvpDisclosure</Role>
      <ShortName>Pay vs Performance Disclosure</ShortName>
      <MenuCategory>Notes</MenuCategory>
      <Position>2</Position>
    </Report>
    <Report>
      <IsDefault>false</IsDefault>
      <HasEmbeddedReports>false</HasEmbeddedReports>
      <LongName>All Reports</LongName>
      <ReportType>Book</ReportType>
      <ShortName>All Reports</ShortName>
    </Report>
  </MyReports>
  <InputFiles>
    <File>txrh-20240516.xsd</File>
    <File>txrh-20240516_def.xml</File>
    <File>txrh-20240516_lab.xml</File>
    <File>txrh-20240516_pre.xml</File>
    <File doctype="PRE 14A" isUsgaap="true" original="txrh-20240516xpre14a.htm">txrh-20240516xpre14a.htm</File>
  </InputFiles>
  <SupplementalFiles>
    <File>txrh-20240516xpre14a_a001.jpg</File>
    <File>txrh-20240516xpre14a_a002.jpg</File>
    <File>txrh-20240516xpre14a_a003.jpg</File>
    <File>txrh-20240516xpre14a_a005.jpg</File>
    <File>txrh-20240516xpre14a_a006.jpg</File>
    <File>txrh-20240516xpre14a_a007.jpg</File>
    <File>txrh-20240516xpre14a_a009.jpg</File>
    <File>txrh-20240516xpre14a_a010.jpg</File>
    <File>txrh-20240516xpre14a_a011.jpg</File>
    <File>txrh-20240516xpre14a_a012.jpg</File>
    <File>txrh-20240516xpre14a_a022.jpg</File>
    <File>txrh-20240516xpre14a_bg001.jpg</File>
    <File>txrh-20240516xpre14a_bg002.jpg</File>
    <File>txrh-20240516xpre14a_cg001.jpg</File>
    <File>txrh-20240516xpre14a_cg002.jpg</File>
  </SupplementalFiles>
  <BaseTaxonomies>
    <BaseTaxonomy items="4">http://fasb.org/us-gaap/2023</BaseTaxonomy>
    <BaseTaxonomy items="4">http://xbrl.sec.gov/dei/2023</BaseTaxonomy>
    <BaseTaxonomy items="213">http://xbrl.sec.gov/ecd/2023</BaseTaxonomy>
  </BaseTaxonomies>
  <HasPresentationLinkbase>true</HasPresentationLinkbase>
  <HasCalculationLinkbase>false</HasCalculationLinkbase>
</FilingSummary>
